function CFE=CFenergy(Data,CMean_m,CMean_v,R,CVar_ga,CVar_gb,...
    Alpha,m_0,v_0,a_0,b_0)

%computing the free-energy for collapsed VB in Gaussian LPD 
%Alpha ---1 x K    normalized Dirichlet parameter

[ns,nf]=size(Data);



K=length(Alpha);


sa=sum(Alpha);
 

Tempbound=0;



%%%% first term involving Alpha

Tempbound=Tempbound+ns*gammaln(sa)-ns*gammaln(sa+nf);


 
 


%the expectation involving the Gaussian
 
temp_ab=CVar_ga.*CVar_gb;
 
 
for d=1:ns
     
temp=reshape(R(d,:,:),nf,K).*...
    (-0.5*log(2*pi)-0.5*temp_ab.*(1./CMean_v+(CMean_m-repmat(Data(d,:)',1,K)).^2)...
    +0.5*(psi(CVar_ga)+log(CVar_gb)));
     
     
     Tempbound=Tempbound+sum(sum(temp));
     
end
 

 


%%%%bit complicate term involving the Gaussian approximation \sum_{d,k}
%%%%{\mathbb E}_q \bigl[\log \gG(\ga_k+\sum_{g}Z_{dg,k})\bigr]

 

MQ = zeros(ns,nf,K)+1e-80;

VARQ = zeros(ns,nf,K);

temp=(R.*(1-R));

for g=1:nf-1
    
   MQ(:,g,:)=reshape(sum(R(:, [g+1 : end], :), 2), ns, 1, K);
   
   VARQ(:,g,:)=reshape(sum(temp(:,[g+1 : end], :), 2), ns, 1, K);
    
end


for k=1:K
   
    MQ(:,:,k)=MQ(:,:,k)+Alpha(k);
     
end

test=R.*(log(MQ)-(0.5*VARQ)./(MQ.^2));

Tempbound=Tempbound+sum(sum(sum(test)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%  compute <q(Z)>_Z


Tempbound=Tempbound-sum(sum(sum(R.*log(R+1e-80))));

 
 
 
 
 
 %KL-divergence w.r.t.  \mu
 
 
temp=0.5.*log(CMean_v./v_0)+0.5.*v_0.*(CMean_m-m_0).^2+0.5.*(v_0./CMean_v-1);

Tempbound=Tempbound-sum(sum(temp));


 


%KL-divergence  w.r.t. \beta


temp=(CVar_ga-a_0).*psi(CVar_ga)+a_0.*(log(b_0./CVar_gb))...
    +gammaln(a_0)-gammaln(CVar_ga)+CVar_ga.*(CVar_gb./b_0-1);


Tempbound=Tempbound-sum(sum(temp));


CFE=Tempbound;


 



