function fe=Free_energy(Data,Mean_m,Mean_v,R,Var_ga,Var_gb,Alpha_0,Alpha,m_0,v_0,a_0,b_0)

%computing the free-energy 
%Alpha_0 ---1 x K    normalized Dirichlet parameter
%Alpha----D x K   posterior   Dirichlet parameter




[no_samp,no_feat]=size(Data);

K=size(Alpha,2);

sa=sum(Alpha,2);

temp_psi=psi(Alpha)-psi(repmat(sa,1,K));




fe=0;



%compute the first term of log likelihood 

%Alpha_0_exp=Alpha_0./sum(Alpha_0);

temp=sum((Alpha_0-1)*(temp_psi'))+no_samp*gammaln(sum(Alpha_0))-no_samp*sum(gammaln(Alpha_0));
 
 
 fe=fe+temp;
 
 temp=[];
 
 
 %second term of  likelihood
 
 
 temp=reshape(sum(R,2),no_samp,K).*temp_psi;
 
 
 fe=fe+sum(sum(temp));
 
 
 temp=[];
 
 %third term of likelihood
 
temp_ab=Var_ga.*Var_gb;
 
 
for d=1:no_samp
     
temp=reshape(R(d,:,:),no_feat,K).*...
    (-0.5*log(2*pi)-0.5*temp_ab.*(1./Mean_v+(Mean_m-repmat(Data(d,:)',1,K)).^2)...
    +0.5*(psi(Var_ga)+log(Var_gb)));
     
     
     fe=fe+sum(sum(temp));
     
end
 
 
 
 
 %compute <log q(\theta)>_\theta
 
 temp=sum(sum((Alpha-1).*temp_psi))...
     +sum(gammaln(sum(Alpha,2)))-sum(sum(gammaln(Alpha)));
 
 
 fe=fe-temp;
 
 
 
 
 %compute <log q(Z)>_Z
 
 
 fe=fe-sum(sum(sum(R.*log(R+(1e-20)))));
 
 
 
 %KL-divergence w.r.t.  \mu
 
 
temp=0.5.*log(Mean_v./v_0)...
    +0.5.*v_0.*(Mean_m-m_0).^2+0.5.*(v_0./Mean_v-1);

fe=fe-sum(sum(temp));


 


%KL-divergence  w.r.t. \beta


temp=(Var_ga-a_0).*psi(Var_ga)+a_0.*(log(b_0./Var_gb))+gammaln(a_0)-gammaln(Var_ga)+Var_ga.*(Var_gb./b_0-1);


fe=fe-sum(sum(temp));


 



